<?php
/**
 * @name srv_control.php
* @description Fichier principal du plugin serveur
* @author Nicolas Biersart <n.biersart@esia-network.com>
* @contributor
* @copyright Nicolas Biersart 2012
* @license
* @esia 1.00
* @version 1.0.0
* @date 09/11/2012
*/

function search_services($name,$arr)
{
	foreach($arr as $service)
	{
		$match ='#'.$name.'#';
		if(preg_match($match,$service['name']))
		{
			return true;
		}
	}
	return false;
}

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
$arr = Model_esia::getWebPlugin($dbconnection,false,'Backup');
include_once($path.$arr[0]['apache_path'].'inc/common_page.inc.php');

if(isset($_GET['action']) && $_GET['action'] == "add_checks"){
	
	if($user->getAccess($dbconnection,"esia_device")&&$user->getAccess($dbconnection,"esia_administration"))
	{
		include_once $path.'/Model_adm.php';
        if( !empty($_REQUEST['select_plugin_object'])){
            $value = $_REQUEST['select_plugin_object'];
            $node=Model_esia::InstanceNode($dbconnection,$srv_id);
            $services = Model_esia::getServices($dbconnection,$node->getId());
            $plugin=Model_esia::getPlugin($dbconnection,$_REQUEST["check"])[0];

            $options = $_GET["options"];
	        $options=str_replace('<JOB_NAME>','"<$JOB_NAME>"',$options);
	        $options=str_replace('<$JOB_NAME>', $value,$options);

            if(preg_match('#\-n\s+("[^"]*"|\'[^"]*\')#',$options,$matches)&& !empty($matches[1])){
                $value = substr_replace($value, "", -1); //Suppression du quote de fin
                $value = substr_replace($value, "", 0); //Suppression du quote de début
                $value = $matches[1];
            }
            else if(preg_match('#\-n\s+(\S+)#',$options,$matches)&& !empty($matches[1])){
                $value = $matches[1];
            }

		    if(empty($_REQUEST["common"])) $name = "JOB $value";
		    else $name=$_REQUEST["common"]." ".$key;

            if(! search_services($name,$services))
		    {
			    Model_adm::addService($dbconnection, $name, $plugin["id"], $node->getId(), $plugin["interval_time"], $options, $plugin["priority"],null,null);
		    }
        }
        else{
		    $checks=$_GET;
		    unset($checks["id"]);
		    unset($checks["action"]);
		    unset($checks["options"]);
		    unset($checks["server"]);
		    unset($checks["check"]);
		    $node=Model_esia::InstanceNode($dbconnection,$srv_id);
		    $services = Model_esia::getServices($dbconnection,$node->getId());
		    $plugin=Model_esia::getPlugin($dbconnection,$_GET["check"])[0];
		    foreach($checks as $key => $value){
		        if (is_array( $value ) ) $value = array_shift($value);
		        $checks[$key] = $_GET["options"];
		        $checks[$key]=str_replace('"<SRC_NAME>"','"<$POSTE_NAME>"',$checks[$key]);
		        $checks[$key]=str_replace('<SRC_NAME>','"<$POSTE_NAME>"',$checks[$key]);
		        $checks[$key]=str_replace('<$POSTE_NAME>', $value,$checks[$key]);
			    if(empty($_GET["common"])) $name = "BACKUPS $value";
			    else $name=$_GET["common"]." ".$key;
			    if(! search_services($name,$services))
			    {
				    Model_adm::addService($dbconnection, $name, $plugin["id"], $node->getId(), $plugin["interval_time"], $checks[$key], $plugin["priority"],null,null);
			    }
		    }
        }
		header('Location: '.$_SERVER['SCRIPT_NAME']."?id=$srv_id");
		exit(0);
	}
}

$node=Model_esia::InstanceNode($dbconnection,$srv_id);
if($user->getAccess($dbconnection,"device_view",$node->getName()) ==1)
{
	//ajout d'un lien pour la navbar
	//$navbar->addNode($node, $ICONS[$node->getType()]);
	$navbar->addNode($node, NULL);
	
	if(isset($_GET['tab'])){
		$smarty->assign('tab',$_GET['tab']);
	}
	else $smarty->assign('tab',0);
	$smarty->assign('l_hardware',$lang['SRV_HARDWARE']);
	$smarty->assign('l_software',$lang['SRV_SOFTWARE']);
	$smarty->assign('l_srv_report', $lang['REPORT']);
	$smarty->assign('l_show_service', $lang['SHOW_SERVICE']);
	$smarty->assign('l_show_historic', $lang['SHOW_HISTORIC']);
	$smarty->assign('l_show_graph', $lang['SHOW_GRAPH']);
	$smarty->assign('control',$arr[0]['apache_path'].'/bck_control.php');
	
	$listState = Model_esia::countNodeState($dbconnection, $node->getId());
	$nbr_error=0;
	//on additionne les erreurs et les services OK (on a ainsi le total des services check et des services passifs)
	$nbr_error=$nbr_error+$listState['critical']+$listState['warning']+$listState['unknown'];
	$smt_status = array('nbr_error'=>$nbr_error,
			'nbr_service'=>$nbr_error + $listState['OK']);
	$smt_status = array_merge ($smt_status,$listState);
	
	$smt_node = array('name'=>$node->getName(),
			'ip'=>$node->getIPv4Adress(),
			'id'=>$node->getId(),
			'description'=>$node->getDescription(),
			'group'=>$node->getGroup()
	);
	$smarty->assign('node_status',$smt_status);
	$smarty->assign('node',$smt_node);
	
	if(!isset($_GET['action']) || $_GET['action'] == "add_checks"){
		$smarty->display($template_path.'bck_control.html');
	}
	else if( $_GET['action'] == 'subtab' ){
		$smarty->display($template_path.'bck_backup_nav.html');
	}
}
?>
